import 'package:flutter/cupertino.dart';

typedef NUIHoverChildBuilder = Widget Function(BuildContext context, bool hovering);

class NUIHoverContainer extends StatefulWidget {
  NUIHoverContainer({this.child, this.builder, this.opacityOnHover: 0.8});
  final Widget child;
  final double opacityOnHover;
  final NUIHoverChildBuilder builder;
  @override
  _NUIHoverContainerState createState() => _NUIHoverContainerState();
}

class _NUIHoverContainerState extends State<NUIHoverContainer>{
  bool hovering = false;

  @override
  Widget build(BuildContext context) {
    return MouseRegion(
      cursor: SystemMouseCursors.click,
      onEnter: (e){

      },
      onHover: (e){
        if(!this.hovering) {
          setState(() {
            hovering = true;
          });
        }
      },
      onExit: (e){
        if(hovering) {
          setState(() {
            hovering = false;
          });
        }
      },
      child: GestureDetector(
        child: AnimatedOpacity(
          opacity: hovering ? (widget.opacityOnHover ?? 0.8) : 1.0,
          duration: Duration(milliseconds: 250),
          child: Container(
            child: widget.builder == null ? widget.child : widget.builder(context, hovering),
          ),
        ),
      ),
    );
  }
}
