import 'package:flutter/cupertino.dart';

typedef NUIStreamWidgetBuilder<T> = Widget Function(BuildContext context, T data);

class NUIStreamController<T>{
  Function(T data) _notify;
  void notify(T data){
    _notify(data);
  }

  void _dispose(){
    _notify = null;
  }
}

class NUIStreamWidget<T> extends StatefulWidget {
  NUIStreamWidget({@required this.initialData, @required this.controller, @required this.builder});
  final T initialData;
  final NUIStreamController<T> controller;
  final NUIStreamWidgetBuilder<T> builder;
  @override
  _NUIStreamWidgetState createState() => _NUIStreamWidgetState<T>();
}

class _NUIStreamWidgetState<T> extends State<NUIStreamWidget<T>> {
  T data;
  NUIStreamController<T> controller;

  @override
  void initState(){
    super.initState();
    data = widget.initialData;
    controller = widget.controller ?? NUIStreamController<T>();
    controller._notify = (data){
      setState(() {
        this.data = data;
      });
    };
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      child: widget.builder(context, data)
    );
  }

  @override
  void dispose(){
    controller._dispose();
    super.dispose();
  }
}
